<%@ include file="../shared/inc_header.jsp"%>

<script type="text/javascript">
	
	setWidgetsInitializedCallback(function() {
		var stationWidget = getWidget('stationId')
		var organizationsWidget = getWidget('organizations')
		var nationalOrLocalWidget = getWidget('nationalOrLocalOrg')

		organizationsWidget.setRefreshParamProvider(function() {
			var nationOrLocal = nationalOrLocalWidget.getParameterValue()
			if(nationOrLocal == 'N') {
				return {
					includeLocal : "false",
					includeNational : "true"
			     }
			}
			else {
				 return {
					    includeLocal : "true",
					    includeNational : "false",
						stationId : stationWidget.getParameterValue()
				}
			}
		})

		nationalOrLocalWidget.addValueUpdatedListener(function(evt, updatedReportParams) {
			var newVal = nationalOrLocalWidget.getParameterValue()
			
			var showNationalOrLocalDependentWidgets = newVal == 'L' 
			stationWidget.toggle(showNationalOrLocalDependentWidgets)
			organizationsWidget.toggle(!showNationalOrLocalDependentWidgets)
			organizationsWidget.refresh()
		})
 
		stationWidget
				.addValueUpdatedListener(function(evt, updatedReportParams) {
					var newVal = stationWidget.getParameterValue()
					var showStationDependentWidgets = newVal && newVal != ''
					organizationsWidget.toggle(showStationDependentWidgets)
				 organizationsWidget.refresh()
				})
	})
</script>


<div
	style="display: inline-block; vertical-align: top; min-width: 400px; text-align: right">
	<div class="clearCenter" style="text-align: center">

		<tiles:insertDefinition name="widgetRadioButtons">
			<tiles:putAttribute name="widgetId" value="nationalOrLocalOrg"
				cascade="true" />
			<tiles:putAttribute name="reportParamName" value="NationalOrg" />
			<tiles:putAttribute name="displayLabel" value="Facility" />
			<tiles:putAttribute name="submitAsReportParameters" value="false" />
			<tiles:putListAttribute name="items" cascade="true">
				<tiles:addAttribute value="National|N" />
				<tiles:addAttribute value="Local|L|Checked" />
			</tiles:putListAttribute>
			<tiles:putAttribute name="bypassAsReportParameters" value="true"
				cascade="true" />
		</tiles:insertDefinition>

		<tiles:insertDefinition name="widgetStationSelector">
			<tiles:putAttribute name="widgetId" value="stationId" cascade="true" />
			<tiles:putAttribute name="reportParamName" value="StationId" />
			<tiles:putAttribute name="displayLabel" value="Select Facility:" />
			<tiles:putAttribute name="bypassAsReportParameters" value="false"
				cascade="true" />
			<tiles:putAttribute name="showAllFacilities" value="false"
				cascade="true" />
			<tiles:putAttribute name="mode" value="single" cascade="true" />
		</tiles:insertDefinition>

		<%-- ====================================== Organization params --%>

		<tiles:insertDefinition name="widgetOrganizationSelector">
			<tiles:putAttribute name="widgetId" value="organizations"
				cascade="true" />
			<tiles:putAttribute name="reportParamName" value="OrganizationID" />
			<tiles:putAttribute name="displayLabel" value="Organizations" />
			<tiles:putAttribute name="includeLocal" value="true"
				cascade="true" />
			<tiles:putAttribute name="includeNational" value="false"
				cascade="true" />
			<tiles:putAttribute name="includeBranches" value="false"
				cascade="true" />

			<tiles:putAttribute name="mode" value="multiple" cascade="true" />
			<tiles:putAttribute name="bypassAsReportParameters" value="false" />
			<tiles:putAttribute name="initialVisibility" value="hidden" />
		</tiles:insertDefinition>

		<%-- ====================================== checkbox params--%>

		<tiles:insertDefinition name="widgetCheckbox">
			<tiles:putAttribute name="widgetId" value="executiveCommittee"
				cascade="true" />
			<tiles:putAttribute name="reportParamName" value="ExecMember" />
			<tiles:putAttribute name="displayLabel"
				value="NAC Executive Committee Members?" />
			<tiles:putAttribute name="submitAsReportParameters" value="true" />
		</tiles:insertDefinition>

		<tiles:insertDefinition name="widgetCheckbox">
			<tiles:putAttribute name="widgetId" value="certifyingOfficial"
				cascade="true" />
			<tiles:putAttribute name="reportParamName" value="NCO" />
			<tiles:putAttribute name="displayLabel"
				value="National Certifying Officials?" />
			<tiles:putAttribute name="submitAsReportParameters" value="true" />
		</tiles:insertDefinition>

	</div>