<%@ include file="../../shared/inc_header.jsp"%>

<tiles:importAttribute name="widgetId" scope="page" />
<tiles:importAttribute name="reportParamNameBegin" scope="page" />
<tiles:importAttribute name="reportParamNameEnd" scope="page" />
<tiles:importAttribute name="initialBeginValue" scope="page" ignore="true" />
<tiles:importAttribute name="initialEndValue" scope="page" ignore="true" />

<script type="text/javascript">
	(function() {
		registerWidget({
			getParameters : function() {
				return [ {
					displayName : "<c:out value="${widgetLabel}" /> From",
					paramName : "<c:out value="${reportParamNameBegin}" />",
					paramValue : $("#${widgetId}_begin").val()
				}, {
					displayName : "<c:out value="${widgetLabel}" /> To",
					paramName : "<c:out value="${reportParamNameEnd}" />",
					paramValue : $("#${widgetId}_end").val()
				} ]
			},
			changeEventSelectors : [ "#${widgetId}_begin", "#${widgetId}_end" ],
			htmlValidationSelectors : [ "#${widgetId}_begin",
					"#${widgetId}_end" ],
			internalValidator: function() { 
				var beginDate = getDateFromMMDDYYYY($("#${widgetId}_begin").val())
				var endDate = getDateFromMMDDYYYY($("#${widgetId}_end").val())
	            if(endDate < beginDate)			
					return 'End Date cannot be before Begin Date'
				else
					return null  
			}
		})
	})()

	$(function() {
		$(["#${widgetId}_begin", "#${widgetId}_end"]).each( function(index, o) {			
			$(o).enableDatePicker({
				showOn : "button",
				buttonImage : imgHomePath + "/calendar.gif",
				buttonImageOnly : true
			})
			$(o).mask(twoDigitDateMask, {
				autoclear : false
			})
		})
	})

	
</script>

<c:out value="${widgetLabel}" />
: 
Begin
<input type="text" id="${widgetId}_begin" ${textInputAttributes}
	value="${initialBeginValue}" style="width:100px"/>
End
<input type="text" id="${widgetId}_end" ${textInputAttributes}
	value="${initialEndValue}" style="width:100px"/>